;MACRODESC BusyObjects animation
;DEFAULTSCALE $SCALE
;PARAMDESCR USER1,USER2,USER3,,,,,,,
;DEFAULTPARAMS 0,0,0,,,,,,,

;====================================================================
;	Airport symbol
;====================================================================


  mif( 0 )
Area( 5 %%1 %%2 1 )
	RotatedCall( :symbol 0 0 %%5 )
	Jump( :endsymbl )
:symbol
	RefPoint( 7 : $SCALE %%1 %%2 )
$SYMPATH
;	Points( 0
;	  -$HWIDTH 0 -$HLENGTH
;	  -$HWIDTH 0  $HLENGTH
;	   $HWIDTH 0  $HLENGTH
;	   $HWIDTH 0 -$HLENGTH
;	)
;	Poly( a 0 1 2 3 )
	Return
:endsymbl
EndA
  mifend

;====================================================================
;	Airport macro
;====================================================================

Area( 5 %%1 %%2 %%3 )

	PerspectiveCall( :Main  )
	Jump(  :  )

:Main
  mif( %%11  )
	RefPoint( 2 :Quit $SCALE %%1 %%2 v1= %%10 E= %%11 v2= $VISRANGE )
  melse
	RefPoint( 7 :Quit $SCALE %%1 %%2 v1= %%10 v2= $VISRANGE )
  mifend
	RotatedCall( :BusyObject 0 0 %%5 )
:Quit
	Return

;====================================================================
;	Object to be animated.
;====================================================================

:Object
	Transform_Mat(
		 0.000  0.000  0.000
		$SRATIO 0.000  0.000
		 0.000 $SRATIO 0.000
		 0.000  0.000 $SRATIO
	)

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	;;   insert object code HERE             ;;
	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	TransformEnd
	Return

;====================================================================
;	Animation control (state machine).
;====================================================================

:StateMachine

	; store COM1 freq in user var #1
	Low64k2Var( $USER01 7BE )

:S1
	; state = "idle" (waiting for activation) ? 
	IfVarRange( :S2 18 1 1 )

		; yes: prepare rendering at start position.
		SetVar( 1E -32768 )
		Call( :PrepareFrame )

		; waiting for activation (COM1 freq = 135.60)
		IfVarRange( :StateMachine_DONE $USER01 0x3560 0x3560 )
			; activated: switch to state "active"
			SetVar( 18 2 )
			; start a new sequence timer
			Call( :StartSequence )
			Jump( :StateMachine_DONE )
:S2
	; state = "active" ?
	IfVarRange( :StateMachine_DONE 18 2 2 )

		; yes: render object at current time code.
		Call( :GetSequenceCode )
		Call( :PrepareFrame )

		; this would run forever, so here is the off-switch
		; (this can be time code based (example) or event based).
		IfVarRange( :StateMachine_DONE 1E $LASTFRAME 32767 )
			; de-activated: switch to state "idle"
			SetVar( 18 1 )

:StateMachine_DONE:
	Return
